$(function(){
  let inputFile = $('#myInput');
  let button = $('#myButton');
  let buttonSubmit = $('#mySubmitButton');
  let filesContainer = $('#myFiles');
  let files = [];
  
  inputFile.change(function() {
    let newFiles = []; 
    for(let index = 0; index < inputFile[0].files.length; index++) {
      let file = inputFile[0].files[index];
      newFiles.push(file);
      files.push(file);
      document.getElementById("mySubmitButton").disabled = false;
    }
    
    newFiles.forEach(file => {
      let fileElement = $(`<div class="filewrapper">${file.name}<div class="status_wrapper"><span class="remove"><svg class="icon icon_remove icon-cancel-circle"><use xlink:href="#icon-cancel-circle"></use></svg>Remove</span></div></div>`);
      fileElement.data('fileData', file);
      filesContainer.append(fileElement);
      
      let removeElement = fileElement.find('span.remove')
                     
      removeElement.click(function(event) {
         let fileElement = $(event.target).closest('div.filewrapper');
         let indexToRemove = files.indexOf(fileElement.data('fileData'));
         fileElement.remove();
         files.splice(indexToRemove, 1);
         if (files.length == 0)
         {
         document.getElementById("mySubmitButton").disabled = true
         }
       });

    });
  });
  
  button.click(function() {
    inputFile.click();
  });
  
  function progress(e){

      if(e.lengthComputable){
          var max = e.total;
          var current = e.loaded;

          var Percentage = (current * 100)/max;
          

          $('.progress_bar').css('width',Percentage+"%");
      }
    }
  

    function updateSubmitLabel() {
      console.log("called");
      console.log(files);
    }


  buttonSubmit.click(function() {
    let formData = new FormData();
    
    $('.controls').hide();
    $('span.remove').fadeOut();

    $('.sending').show();
                     
    document.getElementById("mySubmitButton").disabled = true

    files.forEach(file => {
      formData.append('file', file);
    });
    
    $.ajax({
      url: 'upload.html',
      data: formData,
      type: 'POST',
      xhr: function() {
            var myXhr = $.ajaxSettings.xhr();
            if(myXhr.upload){
                myXhr.upload.addEventListener('progress',progress, false);
            }
            return myXhr;
      },
      success: function(data) { $('.controls').hide(); $('.sending').hide(); $('.success').show();  },
      error: function(data) { $('.controls').hide(); $('.sending').hide(); $('.failure').show();  },
      cache: false,
      processData: false,
      contentType: false,
    });
  });

// Draggy droppy

let dropArea = document.getElementById('drop-area')

;['dragenter', 'dragover', 'dragleave', 'drop'].forEach(eventName => {
  dropArea.addEventListener(eventName, preventDefaults, false)
})

function preventDefaults (e) {
  e.preventDefault()
  e.stopPropagation()
}

;['dragenter', 'dragover'].forEach(eventName => {
  dropArea.addEventListener(eventName, highlight, false)
})

;['dragleave', 'drop'].forEach(eventName => {
  dropArea.addEventListener(eventName, unhighlight, false)
})

function highlight(e) {
  dropArea.classList.add('highlight')
}

function unhighlight(e) {
  dropArea.classList.remove('highlight')
}


dropArea.addEventListener('drop', handleDrop, false)

function handleDrop(e) {
  let dt = e.dataTransfer
  let r_files = dt.files


  console.log(r_files)
  let newFiles = []; 
  
  ([...r_files]).forEach( function(file) {

    console.log(file);

    files.push(file);
    newFiles.push(file);
    document.getElementById("mySubmitButton").disabled = false;

  });

  newFiles.forEach(file => {
    let fileElement = $(`<div class="filewrapper">${file.name}<div class="status_wrapper"><span class="remove"><svg class="icon icon_remove icon-cancel-circle"><use xlink:href="#icon-cancel-circle"></use></svg>Remove</span></div></div>`);
    fileElement.data('fileData', file);
    filesContainer.append(fileElement);

    console.log("In here")
    console.log(fileElement)
    console.log(filesContainer)
    console.log("End here")

    let removeElement = fileElement.find('span.remove')
    
    removeElement.click(function(event) {
      let fileElement = $(event.target).closest('div.filewrapper');
      let indexToRemove = files.indexOf(fileElement.data('fileData'));
      fileElement.remove();
      files.splice(indexToRemove, 1);
      if (files.length == 0)
      {
          document.getElementById("mySubmitButton").disabled = true
      }
    });
  }); 
}



});
